Changelog XRechnung.odb ab XRechnung_2502_001.odb

Neue Versionen zur XRechnung werden immer dann erstellt, wenn ein Fehler bereinigt wurde oder eine zusätzliche Funktion hinzu gekommen ist.
Wird eine Version mit gleicher Versionsbezeichnung neu hoch geladen, so betrifft die Änderung keine Funktionen der Datenbank sondern lediglich Codebereinigung.

* XRechnung_2502_001.odb
- Warenverwaltung aufgenommen
- Formulare übersichtlicher gestaltet
- erweiterte XRechnungen einfacher eingebbar

* XRechnung_2502_002.odb
- Warenverwaltung: Steuerangabe zu Pflichtfeldern, Preise zuerst von der Eingabe des StartDatums in der Rechnungszeile abhängig gemacht
- Kopieren von Rechnungen auch für Rechnungen der Warenverwaltung ermöglicht
? Fehlende Inhalte in "tbl_Steuer_Anmerkung" nachgetragen und Leeren der Tabelle beim Update raus genommen.

* XRechnung_2502_003.odb
- Pflichtfelder im Bereich Steuern und Warenverwaltung in den Tabellen gesetzt.
- Zahlungsnotizen als Standard für Lieferscheine, Angebote usw. ermöglichen (tbl_Rechnungstyp_Code).

* XRechnung_2502_004.odb
- Vorhergehende Angebote, Lieferscheine und Auftragsbestätigungen erscheinen jetzt unter "Anmerkungen" oberhalb der Rechnung, nicht mehr in der Rechnungssummierung.
- Update aus vorheriger Version für tbl_Bankverbindung korrigiert. Die Tabelle wurde zu spät eingelesen.

* XRechnung_2502_005.odb
- Anzeige von Rechnungen in den Eingabeformularen korrigiert. Es erscheinen keine Rechnungen mehr, die komplett bezahlt sind. Es erscheinen auch keine Belege mehr, die mit aktuelleren Belegen verknüpft wurden.
- Im Kontoformular erscheinen nur noch Rechnungen, keine Angebote o.ä.

* XRechnung_2502_006.odb
- Anzeige der Beträge in der ausgedruckten Rechnung ohne Währungszeichen über das Format "CurrencyNum" eingebaut.
- Alternative Währungsangabe für die Rechungen möglich (allerdings: Anzeige in Formularen etc. weiter als ¤).
- Steuercodeangabe in erweiterten XRechnungen korrigiert.

* XRechnung_2502_007.odb
- Anzeige anderer Währungen auf alle Rechnungsformulare ausgeweitet
- kleinere Korrekturen (Messagebox beim Druck vergessen zu deaktivieren).

* XRechnung_2502_008.odb
- Bruttobetrag und laufende Summierung in den Rechnungszeilen
- Erweiterte XRechnung zur freien Eingabe auf allen 3 Ebenen wieder hinzugefügt (Achtung! Summierungen vor dem Druck überprüfen!)

* XRechnung_2502_009.odb
- Defaultsteuersatz und Defaultsteuercode in tbl_Firma von der tbl_Steuerart und dem Datum abhängig erstellt.

* XRechnung_2502_010.odb
- Andere Währungen in XML-Dateien: Bisherigen Code korrigiert, da noch EUR als Code fest in den Makros verankert war.
- Steuerfreiheit auch in die erweiterten Rechnungseinstellungen übernommen (Änderung der Währung kann Steuerfreiheit beinhalten).
- Druck von Zeilennummern korrigiert - wurde bei den Spalten für die Rechnung nicht mehr berücksichtigt.

* XRechnung_2502_011.odb
- Das Feld "KundeZeichen" wurde aus der Rechnungsvorlage entfernt. Es war für die Leitweg-ID der Behörden gedacht. Die ist aber abhängig vom Kunden, nicht abhängig von der Rechnung. Der Eintrag erfolgt jetzt im Formular "Kunde" unter der "Leitweg-ID/Kundenkennung". Das Feld "KundeZeichen" in "tbl_Rechnung" bleibt im Hintergrund bestehen, damit die alten Rechnungen weiter Bestand haben.

* XRechnung_2502_012.odb
- Feld "KundeZeichen" auch im Formular "Rechnung", allerdings nicht mahr als verpflichtendes Feld. Wird im Formular "Rechung" ein Eintrag getätigt, so gilt dieser für die spezielle Rechnung. Ansonsten zieht der Eintrag aus dem Formular "Kunde". Ist auch dort kein Eintrag, so wird die interne Kundennummer genommen.

* XRechnung_2502_013.odb
- Wiederherstellung von einigen Funktion im Formular "frm_Lieferung_Aenderung" zur Weiterleitung von Lieferungen.
- Einlesen von Rechnungen war nach Version 2502_010 wegen eines falschen Währungszusatzes nicht mehr möglich ? wiederhergestellt.
- Einlesen von Rechnungen: Rabatte und Aufschläge berücksichtigen jetzt Anzahl der Waren in der Rechnungszeile

* XRechnung_2502_014.odb
- BIC wird in jeder XML-Rechnung mit angegeben. So sind neben den anderen SEPA-Statten auch Rechnungen nach San Marino, Monaco, Schweiz, Saint Pierre und Miquelon möglich.
- Beim Einlesen aus früheren Versionen wurden teilweise nur 3 Tabellenfelder in den Tabellen der Rechnungsformulare angezeigt - korrigiert
- Die Listung von Bezügen zu anderen Rechnungen in viw_Rechnung verlangsamte die Ansicht bei vielen Rechnungen deutlich. Durch Unterabfrage korrigiert.

* XRechnung_2502_015.odb
- Bei erweiterten XRechnungen erschienen die Gliederungspunkte trotz eigeschalteter Nummerierung ohne Nummer - korrigiert
- Bei erweiterten Rechnungen wurde der Defaultwert sowie die Schreibberechtigung für einige Felder nicht korrekt gesetzt - behoben.

* XRechnung_2502_016.odb
- Vom Kunden abhängige Spaltenbezeichnungen für Ware, Warennummer und Warenzusatz können jetzt auch im Rechnungsformular eingeblendet und geändert werden. Die Änderung erscheint auch in den Druckeingenschaften der Rechnung.
- Beispiel für das Einstellen von Standarddatumswerten in den Makros bereitgestellt. Werte wie Anfangsdatum und Enddatum des Vormonats oder eines beliebigen Monats können über viw_Filter ausgefüllt werden und dann z.B. für das Lieferdatum genutzt werden. Beispiel unter Inputcontrol ? FormChange, ca. Zeile 125

* XRechnung_2502_017.odb
- Rechnungsformulare mit Comoboxen hinzugefügt. Ware wird in Abhängigkeit vom Kunden vorgeschlagen oder kann dort frei eingetragen werden.
- Formularfelder, sofern bisher nicht andersfarbig dargestellt, einheitlich auf weißen Hintergrund eingestellt.

* XRechnung_2502_018.odb
- Die Erstellung der Mail wird jetzt mit Zeitstempel abgespeichert. Im Einstellungsformular kann eingestellt werden, wie lange eine Rechnung nach der Mailerstellung noch bearbeitbar sein soll.
- Steuerfreie Rechnungen innerhalb der EU konnten mit ZUGFeRD nicht komplett erstellt werden - korrigiert
- Umsatssteuernummer des Empfängers, sofern vorhanden, wird jetzt auch im Druck mit angezeigt.

* XRechnung_2502_019.odb
- Fehler bei Listboxen in frm_Rechnung-Extension-2_W beseitigt.
- Nicht benutzte Abfragen durch "X_" gekennzeichnet.
- Nicht benutzte Makros durch "X_" gekennzeichnet.
- Fehler in "viw_Rechnung_Ausgang" bei der Zeilennummer in erweiterten Rechnungen beseitigt.
- Fehler bei der Zahlung von eingegangenen Lieferungen beseitigt.
- Plural der Maßeinheiten war bisher auf Werte > 1 beschränkt. Jetzt für die Maße, die nicht dem Betrag '1' entsprechen.
- viw_Lieferung_Aenderung: Druckerstellung war nicht möglich, auch andere Ansichten Angepasst an die Rechnungsansichten.
- Filterung im Kontoformular verbessert
- Privatkunden können mit Firmenbezeichnung aufgenommen werden - es wird nur Ansprechpartner in die Adresse der PDF-Datei übernommen.
- Bei Gliederungen für erweiterte XRechnungen können auch die Summen für die Gliederung angezeigt werden.
- QRCode wurde bei der Erstellung mit automatischer Größe erzeugt. Dies führte zu einem recht kleinen Bild, wenn der QRCode das letzte Element auf einer Seite mit wenig Platz war. Der QRCode wird jetzt von der Größe auf die Breite und Höhe der letzten Spalte eingestellt.
* Die wichtigste Neuerung: Zur 2502_019 existiert jetzt auch die erste Serverversion für MariaDB/MySQL. Hier sind die Daten dann auch für mehrere User gleichzeitig nutzbar.

* XRechnung_2502_020.odb
- MariaDB: Ansichten vom Import per SQL ausgenaommen ? muss von der Base-Datei aus erfolgen.
- MariaDB: Startwerte der Autoincrementfelder angepasst

* XRechnung_2502_021.odb
- MariaDB: Einige Listenfelder korrigiert - zeigten '0' an.
- MariaDB: Viele Ja/Nein-Felder wurden beim Export zu einstelligen Textfeldern - korrigiert
- MariaDB: Zahlungsnotizen erschienen nur, wenn auch Skonto gewährt wurde - korrigiert (Ansichten neu erstellen!)
- Filterfelder im Kundenforumlar und im Lieferantenformular wurden erst beim Neustart aktualisiert. Die Aktualisierung erfolgt jetzt nach jedem Abspeichern eines Kunden- bzw. Lieferantendatensatzes.

* XRechnung_2502_022.odb
- MariaDB: Kontoeingabe für Rechnungen funktionierte nicht - behoben.
- Rechnungskopien wurden mit der gleichen Rechnungsnummer erstellt - behoben.
- Rechnungssuche: Warnung zu anderer Währung als dem Euro wurde nicht angezeigt - korrigiert

* XRechnung_2502_023.odb
- Reihenfolge der Rechnungsposten nicht immer im Einklang mit lfd. Nummerierung - korrigiert
- Für Rechnungsformulare ist eine Rechnungspostenübersicht hinzu gekommen. Die Übersicht kann im Formular "Einstellungen" auf 'sichtbar' geschaltet werden. Um dies mit der MariaDB zu ermöglichen muss das Makro Update ? StartNewField ablaufen. Dadurch wird das Feld der Datenbank hinzugefügt. Die Übersicht ist nur sinnvoll, wenn in verschiedenen Rechnungsmodulen gearbeitet wird, weil eine Rechnungszeile mit Warenauszahl in einer einfachen Rechnung nicht angezeigt wird. Gleiches gilt für Rechnungen mit Untergliederungen (erweiterte XRechnungen).
- Suche beinhaltete nicht die Waren aus den Formularen für Waren auswahl - korrigiert
- Die Kontoübersicht wurde um eine Zuweisung der Konten zu den Zahlungen und eine Berichtsfunktion für die gesamten Kontobewegungen erweitert.
- Für das Lieferdatum wurde eine Änderung der Beschriftung für die jeweilige Rechnung ermöglicht. Es können so jetzt statt "Lieferdatum:" auch Begriffe wie "Ausgeführt am:", "Abgeholt am:" oder ähnliches eingefügt werden.
Hinweis: Bei der MariaDB beachten: Die Ansichten müssen auch bei jedem Update neu erstellt werden. Sonst kommen Änderungen bei den Formularen nicht an. Bitte die Anleitung dazu beachten!

* XRechnung_2502_024.odb
- Rechnungen können jetzt auch mit Preisangaben als Bruttopreisen erstellt werden. Der Nettopreis wird bestimmt und die Steuer dazu berechnet, so dass der Bruttopreis genau erreicht werden kann.
- Kontoübersicht: Nur einzelene Monate auswählbar, jetzt auch alle Monate eines Jahres
- In vielen Formularen tauchten noch die zusätzlichen Navigationsleisten im Fenster unten auf. Das führte teilweise zu Irritationen. Diese Leiste ist jetzt in allen Formularen ausgeschaltet.
- Die Verbindung zu Angeboten, Auftragsbestätigungen u.ä. war nur auf eine Verbindung beschränkt. Jetzt können mehrere Rechnungen mit einer Auftragsbestätigung verbunden werden.
- Die Listenfelder für die weiteren Verbindungen (siehe oben) wurden nicht korrekt erstellt - korrigiert.

* XRechnung_2502_025.odb
- Mahnungsdruck ergänzt mit gesonderter Druckvorlage für bis zu 3 Mahnstufen, Mahngebühr und Verzugszins. Gebühren können in den zusätzlichen Rechnungseinträgen vermerkt werden (siehe Beschreibung).
- Kundenverwaltung: Auf besonderen Wunsch ein Feld für den Vornamen eines Kunden im Bereich "Ansprechpartner" hinzugefügt. So können Daten aus anderen Datensätzen eventuell leichter übertragegen werden. Der Vorname ist nicht notwendig und taucht auch in der XRechnung nicht weiter auf. Er wird nur bei der Erstellung berücksichtigt, wenn das Feld auch einen Inhalt hat.
- Rechnungsabsicherung: Nach der Speicherung erfolgt eine Abfrage, ob die Datei an das Mailprogramm weitergeleitet werden soll. Bei der ersten Weiterleitung wird das Versanddatum abgespeichert.

* XRechnung_2502_026.odb
- Dateibezeichnungen für Anhänge stimmen bei Änderungen des Kürzels für Rechnungen nicht mit der Rechnung überein. Korrigiert auf die vorgegebenen Kürzel - werden jetzt aus der gleichen Quelle gelesen. Wird ein Dateianhang vor dem Drucken eines Dokuments eingelesen, so wird die Rechnung bereits zu diesem Zeitpunkt mit einer festen Rechnungsnummer versehen.
- Steuerbefreiung für Kleinunternehmen und andere Gründe: Einträge in den zusätzlichen Rechnungsangaben (Porto etc.) wurden in den xml-Dateien nicht mit der entsprechenden Steuerbezeichnung und dem 0-Prozentsatz versehen. Dadurch waren die XRechnungen nicht valide. Korrigiert.
- Dateibezeichnungen bei Anhängen für eingegangene Lieferungen hatten nichts mit den Dateibezeichnungen der Lieferungen zu tun. Korrigiert.
- Erweiterte Rechnungseinstellungen bei der Rechnungssuche und der Aufnahme von Lieferungen brachten einen Makrofehler. Unnötige Makros aus dem Formular entfernt.

* XRechnung_2502_027.odb
- Bei Rechnungen mit der Warenverwaltung fehlen Preise, wenn das "abDatum" bei der Preisgestaltung nach dem Rechnungsdatum liegt. Hier erfolgt jetzt in den Listenfeldern eine entsprechende Warnung.
- Bei Speichern von Mahnungen wurde die XRechnungs-Erstellung ausgelöst - korrigiert.
- Beim Import aus Calc-Tabellen wurde der Datenbankname in der MariaDB-Version nicht ausgelesen - korrigiert.

* XRechnung_2502_028.odb
- Im Formular "Konto" war es möglich, Buchungen vor dem Rechnungsdatum vor zu nehmen. Bei fehlerhaften Eingaben landen solche Buchungen im falschen Monat, eventuell auch im falschen Jahr. Ein Makro setzt jetzt das Rechnungsdatum als Minimum für das Buchungsdatum.

* XRechnung_2502_029.odb
- In den Ausdrucken erschien teilweise ein doppeltes Leerzeichen bei der Adresse. Das ist (hoffentlich) jetzt korrigiert.
- Beim Ausdruck von erweiteren XRechnungen wurde der Betrag für die Hauptgliederungen linksbündig ausgegeben. Die Zuweisung der Rechtsbündigkeit erfolgt jetzt nach der Zuweisung des Absatzformates.
- Beim Ausdruck tauchte trotz Steuerfreiheit bei teilweise bezahlten Rechnungen "offen (Netto)", "offen (Steuer)" und "offen (Brutto)" auf. Das wurde auf eine Zeile mit "offen" reduziert.
- In erweiterten Rechnungen war die Sortierung der Einträge bei entsprechender Eingabe fehlerhaft.
- Bei der MariaDB funktionierte die Abfrage in der Rechnungseingabe nicht einwandfrei zusammen mit der GUI.

* XRechnung_2502_030.odb
- Einige Ansichten funktionierten nur innerhalb von Base, nicht aber in PHPMyAdmin. Probleme mit der Collation innnerhalb von "viw_Rechnung" konnten behoben werden.
- Der Rechnungsdruck ist jetzt um die Funktion erweitert, dass auch englischsprachige Rechnungen möglich sind. Die englischsprachige Version wird gewählt, wenn das Zielland nicht DE, AU oder CH ist. 
Hinweis: Die Mahnungsvorlage wurde nicht übersetzt. Auch die sonstigen Übersetzungen sollten in dem Einstellungsformular überprüft werden. Die Englischkentnisse des Autors reichen zwar für Bugbeschreibungen, nicht aber für das Schriftenglisch im Wirtschaftsbereich?
- Die Rechnungsnummer erschien nicht, wenn eine Rechnung direkt nach der Erstellung gedruckt wurde. Korrigiert.

* XRechnung_2502_031.odb
- Übersetzung Englisch für Zahlungsnotizen erweitert. Einige andere Felder waren auch nicht übersetzt?
- Kopieren von Rechnungen jetzt auch so möglich, dass eine Kopie von einer Rechnung direkt einem anderen Kunden zugewiesen werden kann.
- Bei einigen Tabellen in den Formularen sind nicht alle Felder zur Änderung freigeschaltet. Die bearbeitbaren Felder sind jetzt gekennzeichnet.
- Durch Hinzufügen von Feldern waren einige Formular bei der Tabulatorreihenfolge durcheinander geradten. Die Reihenfolge wurde in jedem Formular überarbeitet.

* XRechnung_2508_001.odb
- Pfadkorrektur beim Einlesen von Anhängen in MariaDB
- Formular frm_Eingang_einfach hinzugefügt. So können Belege, die nicht als XRechnungen existieren, wenigstens für Buchungszwecke aufgenommen werden.
- Listenfelder in Formularen zeigten meist nur maximal 5 Einträge an. Der Rest musste gescrollt werden. Auf 20 Einträge erhöht.
- Sprachtabelle tbl_Sprache_EN abgesichert, damit diese nicht beim Update von einer vorherigen Version ohne Sprachtabelle geleert wird.
- Neue Variablen in XRechnung übernommen: Gruppe Buyer Contact [BG-9] mit den Elementen ?point [BT-56], ?telephone number [BT-57] und ?email address [BT-58]. Tabelle tbl_Kunde sowie das entsprechende Formular erweitert.
- Automatisches Schließen der Base-Datei nach dem Schließen des letzten Formulars überarbeitet. Dazu ist eine Prozedur erforderlich, die über die Beschreibungsdatei installiert werden kann. Die Beschreibungsdatei ist deshalb als *.odt-Datei dabei und muss die Ausführung von Makros erlaubt bekommen. In der Datei befindet sich in dem Kapitel "Beenden von Base nach dem Schließen des letzten Formulars" ein Button für die Installation.
- Fehlerkorrekturen bei der Direkteingabe von Lieferanten. Ein Abspeichern war hier nicht möglich, da ein Pflichtfeld nicht vorhanden war.

* XRechnung_2508_002
- Ausgabe leerer Berichte (Lieferungen, Konto) durch Vorabfrage unterbunden.
- Bericht "rpt_Lieferung" etwas kompakter gestaltet (Rechnungszeilen mit Schriftgröße 10 pt gegenüber vorher 12 pt)
- Kontoübersicht auch nach Quartalen erstellbar

* XRechnung_2508_003
- Rechnungsnummern und Nummern für Angebote, Lieferscheine usw. wurden bisher in einem fortlaufenden Nummernkreis verwaltet. Jetzt sind alle Rechnungen, zu denen eine XRechnung erstellt wird, in einem Nummernkreis. Alle weiteren Rechnungstypen (Angebot, Lieferschein, Auftragsbestätigung ?) sind in einem getrennten Nummerkreis zusammengefasst. Um die Nummerierung nicht komplett durcheinander zu bringen: Sind bisher nur Rechnungen erstellt worden, so kann ein Update gemacht werden. Wurden bereits Angebote, Lieferscheine o.ä. erstellt, so sind alle Dokumente zusammen in einem Nummernkreis. In diesem Fall sollte erst zum nächsten Jahr ein Update erfolgen.

* XRechnung_2508_004
- Erstellte Rechnungen konnten später nicht mehr einwandfrei ausgedruckt werden, wenn Zahlungen erfolgt waren, da alle Zahlungen und nicht nur Zahlungen bis zur Rechnungserstellung berücksichtigt wurden.
- Bei Skontoberechnungen wurden falsche Beträge erstellt werden, wenn einzelne Posten nicht skontierbar waren.
- Bei Sicherheitseinbehalt (zur Gewährleistung) war kein Skonto möglich. Skonto wird jetzt ab einem prozentualen Gesamtbetrag gewährt (Standard: 100%).
- Teilrechnungen wurden nicht kumulierend gehandhabt. Jetzt kann der Inhalt der 1. Rechnung in der 2. Rechnung erscheinen usw.
- Bei Stornierungen entstehen Gutschriften (381/389), die bisher mit positivem Betrag im Konto aufgeführt wurden. Gutschriften werden jetzt grundsätzlich mit negativem Betrag aufgeführt, damit sie die Rechnung ausgleichen. In der Gutschrift selbst ist sowohl ein negativer als auch ein positiver Betrag möglich.
- Rechnungen in dem Suchformular konnten nicht mehr direkt gedruckt werden. Jetzt ist von dort aus die Rechnung als PDF-Datei aufrufbar.

* XRechnung_2508_005
- MariaDB: Zahlungsnotizen wurden durch eine Klammer an der falschen Position nur ausgegeben, wenn die Rechnung mit Skonto versehen war. 
- MariaDB: Buchungen über das Kontoformular waren für ausgehende Rechnungen nicht möglich, da Haupt- und Unterformular nicht richtig verknüft waren.
- Skontoeingaben sind mit zusätzlichem Schutz versehen. So ist jetzt zuerst eine Eingabe von Skonto1 erforderlich, danach eine Angabe der Tage ab Rechnungsstellung für dieses Skonto, bevor auch eine Angabe von Skonto2 möglich ist.

* XRechnung_2508_006
- Skonto wurde bisher gegeben, wenn bei der Rechnung oder beim Kunden Skonto angewählt war. Jetzt setzt die Einstellung beim Kunden nur den Standardwert für die Rechnung. Dort kann also Skonto auch abgewählt werden. Ist beim Kunden kein Skonto angewählt, so kann auch in der Rechnung Skonto nicht ausgewählt werden.
- Für Gutschriften wurde eine Zahlungsnotiz hinzugefügt.
- XRechnungserstellung war beim Umstellen auf die Skontoänderungen defekt. Behoben.
- Stornierung und Rechnungskorrektur wurden überarbeitet

* XRechnung_2508_007
- Zahlungsberechnung für weitergeleitete Lieferungen passte nicht mehr zur XRechnungs-Erstellung. Angepasst.
- Weitergeleitete Rechnungen konnten nach eingegangenen Zahlungen nicht mehr korrekt erstellt werden. Angepasst.
- Bei korrigierten Rechnungen konnte beim noch offenen Betrag auch ein negativer Wert erscheinen. Da das eine Zahlung der Firma an den Kunden ist durfte dort kein QRCode zum Überweisen erscheinen.
- Bei negativen offenen Beträgen oder ausgeglichenen Rechnungen erscheint eine (sprachlich angepasste) Meldung statt des Girocodes.
- Die Kontoübersicht ist jetzt auch als Auszug in Calc verfügbar. Hierfür muss nur der Bericht rpt_Kontostand in rpt_Kontostand_Writer und der Bericht rpt_Kontostand_Calc in rpt_Kontostand umbenannt werden.

* XRechnung_2508_008
- Im Kundenformular ist jetzt unabhängig von der Landeseinstellung die Wahl einer anderen Rechnungssprache möglich.

* XRechnung_2508_009
- In XRechnungen ist kein Leistungsdatum notwendig. Nach § 14 Abs. 4 Satz 1 Nr. 6 UStG ist solch ein Datum aber erforderlich. Deswegen wird, wenn kein Lieferdatum vermerkt ist, das Rechnungsdatum ab sofort als Leistungsdatum eingesetzt.
- Bei den alternativen Bankverbindungen der Firma fehlte ein Feld für den Zahlungsempfänger. Falls dieser unterschiedlich zum Zahlungsempfänger des Hauptkontos ist kann das nach neueren Regeln (IBAN und Zahlungsempfänger müssen stimmen) zu Problemen führen.
- In den allgemeinen Einstellungen sind jetzt auch der Landescode und der Währungscode enthalten. Es können jetzt also Rechnungen grundsätzlich auch aus anderen Ländern erstellt werden und mit einer entsprechenden Währung versehen werden. Bisher war nur die alternative Währung für Rechnungen separat einstellbar.
- Bei der Warenverwaltung ist das Feld "Warenzusatz" bisher nur über die Warenverwaltung einstellbar. Jetzt kann der Inhalt "Warenzusatz" auch neben der Auswahl der Warenverwaltung für jeden Rechnungsposten separat eingestellt werden.

* XRechnung_2508_010
- Bei Rechnungen mit anderer Währung wird die Währung jetzt auch in den Feldern des Formulars sowie direkt im Rechnungsdruck angezeigt.
- Eine grundsätzliche Einstellung der Währung ist ebenfalls möglich, wenn das Programm z.B. standardmäßig aus der Schweiz betrieben werden soll.
- Eine Eingabe des aktuellen Umrechnungskurses zur Standardwährung bei separaten Währungen für eine Rechnung ist möglich. So kann die Kontoführung in einer Währung durchgeführt werden.
- Ein Eintrag für ein Währungskürzel ist zur Zeit nur in "tbl_Currency_Code" möglich. Ohne Kürzel wird einfach der ISO-Code genommen.

* XRechnung_2508_010
- Währungsumstellung auch bei Lieferungen und Weiterleitung von Lieferungen eingebaut
- Mit Eingabe des Wechselkurses ist auch bei Lieferungen so eine Kontoführung mit verschiedenen Währungen möglich.
- Fehler bei der Neueingabe von Rechnungen behoben (Umstellung der Währung ließ zwischendurch das Formular hängen?)

* XRechnung_2508_011
- In der Firebird-Version fehlte zum Export eine Ansicht.

* XRechnung_2508_012
- Bei der Kontoführung kann jetzt alternativ auch ein Ausdruck mit zusätzlichen Steuerangaben ausgegeben werden. Der bisherige Ausdruck gibt nur das Bruttoresultat für das Konto an.

* XRechnung_2508_13
- Bereits gezahlte Beträge wurden bei der Summierung viw_Lieferung_Summe und viw_Lieferung_Summe_Änderung nicht berücksichtigt - korrigiert.
- MariaDB: Der anschließende Rechnungsausdruck über die Rechnungssuche war falsch verknüpft - korrigiert.
- Das "Reverse_Charge-Verfahren" benötigt beim Kunden ein Eintrag für die UST-IdNr. Das wurde bisher nicht abgefragt und konnte zu fehlerhaften XRechnungen führen.

* XRechnung_2508_14
- Bei mehreren Rechnungsposten konnte es vorkommen, dass in der Summierung Netto, Steuer und Brutto nicht mehr genau zueinander passten (Rundungsprobleme im Bereicht von wenigen Cent). Da es Validatoren gibt, die solche Dokumente dann ablehnen (Nur die Summe ist mit 2 Nachkommastellen korrekt anzugeben - keine Bruttoangaben bei Rechnungszeilen) wurde das durch eine Erhöhung der Nachkommastellen für den Steueranteil und den Bruttobetrag bei den Rechnungszeilen behoben. Achtung!!! - bei Nutzung des Kontoformulars kann es jetzt passieren, dass bereits ausgeglichene Rechnungen wieder auftauchen, weil ein paar Cent fehlen oder zu viel gebucht wurden. Vermutlich gleichen sich die Buchungen schließlich aber weitgehend aus, so dass einfach diese entsprechenden Unterschiedsbeträge zusätzlich eingegeben werden sollten.
- Die Auswahlmöglichkeit von Währungsanzeigen für die Formulare führte bei neuen Kunden bei ersten Rechnungen zu einer Fehlermeldung. Gleiches passierte im Mahnungsformular, wenn keine anmahnbare Rechnung existierte.

* XRechnung_2508_15
- Thunderbird-Nutzer von manchen Linux-Distributionen haben Probleme mit dem Inhalt der erstellten Mails gehabt. Hierfür wurde jetzt eine gesonderte Prozedur im Modul XRechnung > StartMail entwickelt. Die Prozedur StartMailThunderbird spricht Thunderbird direkt auf der Konsole mit dem compose-Parameter an und kann auch HTML-Mails sowie die Vorbelegung des Absenders (bei mehreren Profilen in Thunderbird sinnvoll). Einfach StartMail durch Umbenennen auf StartMail1 deaktivieren und StartMailThunderbird zu StartMail umbenennen.
- Eingabeformular für die vereinfachte Aufnahme von Lieferungen vereinfacht.
- In der Beschreibung Suche für das Code-Formular ergänzt.

* XRechnung_2508_016
- Bei der einfachen Liefereingabe wurden Defaultwerte für die Steuer mit eingebaut, sofern sie in den Einstellungen für Rechnungen angegeben sind.

* XRechnung_2508_017
- Die Möglichkeit der Validierung der erzeugten Dateien wurde mit eingebaut. Sie funktioniert nur mit einer möglichst aktuelle Mustang_?.jar. Hier getestet mit Mustang-Cli-2.20.0.jar. Die Validierung hat 2 Probleme:
1. Die erzeugte PDF-Datei mit dem Validierungsergebnis wird immer in dem Verzeichnis abgelegt, von dem aus die Base-Datei gestartet wurde. Bei einem direkten Klick auf die Datei ist das das Verzeichnis, in dem auch das Archiv liegt. Bei einem Start von LibreOffice über das Startmenü kann das aber z.B. das Homeverzeichnis des Nutzers unter Linux sein. Ein Speicherort für die Datei lässt sich leider bisher nicht mit angeben.
2. Das Validieren und Abspeichern dauert auch bei kleinen Rechnungen ca. 1 Minute. Wer ungeduldig ist sollte die Funktion also nur in Ausnahmefällen nutzen.
- Aus der Rechnungssuche kann ein Bericht gestartet werden, der Netto, Steuer, Brutto sowie offene Beträge zu erstellten Rechnungen ausgibt. Wie beim Konto kann der Zeitraum der Ausgabe vorgegeben werden.

* XRechnung_2508_018
- Es gibt Nutzer, die die DB zur Erstellung von XRechnungen als einzige Buchungsverwaltung nutzen wollen. Für diese Nutzer wurde neben der einfachen Eingabemöglichkeit von Lieferungen ohne XRechungs-Belege die periodische Buchung hinzugefügt. Es wird damit jeweils der letzte Datensatz der periodischen Buchung hinzugefügt, wenn das entsprechende Datum erreicht wird. Das Hinzufügen geschieht beim Öffnen der Datenbank. Die Periodenvermerke bei älteren Datensätzen werden entfernt, wenn ein neuer Insert zu der Buchung erfolgt ist. Bei Änderungen des Betrages muss immer der Datensatz bearbeitet werden, der mit dem Vermerk der Periode versehen ist.
- Aus dem Lieferformular kann jetzt wie aus der Rechnungssuche eine Übersicht zu den Lieferungen gestartet werden.

* XRechnung_2508_019
- Fehlt ein Eintrag für das Startformular, so konnte dies zu einer Fehlermeldung im Makro führen.
- Der Start des Makros für die periodischen Buchungen wurde an das Ende der Prozedur "FilterStart" gelegt. So ist der Wechsel der MariaDB-Datei wieder wie gewohnt möglich (nach der Verbindung nur den Aufruf von "FilterStart" zusätzlich freischalten).
- Wenn zu einem Kunden noch keine Rechnungen existierten kam es mehrmals zu der Meldung, dass noch keine Rechnung existiert. Gleiches bei Mahnungen. Dieses Verhalten ist mit der Umstellung der Währungsanzeige dazugekommen. Die Meldung habe ich raus genommen, das Startverhalten verbessert.
- Bei der Erzeugung der XRechnung bzw. ZUGFeRD-Rechnung war ein Tippfehler drin, der für steuerfreie Rechnungen zu einem Verweis im Makro führte. Der Code dazu war in einem der letzten Updates hinzu gekommen, ist jetzt bereinigt.

* XRechnung_2508_020
- Lieferantennummer und Lieferanten_ICD_Code waren bisher nur in der Tabelle "tbl_Kunde" anwählbar. Jetzt gibt es das Feld auch zusätzlich in den Firmeneinstellungen. Werden beide Eingaben genutzt, so erscheinen auch beide Eingaben in der XRechnung. Beim Kunden gilt der Lieferanten_ICD_Code für das neu hinzugefügte Feld "LieferantenNr. Kunde" [BT-46]. Das alte Feld "Lieferantennummer" ist die Nummer, die die eigene Firma beim Kunden hat.
- Einträge in RegisterE2 [BT-33] können jetzt auch in Englisch in dem Einstellungsformular erfolgen.
- Als Ergänzung zur Adresse wurde [BT-51] für den Empfänger hinzugefügt. Das ist zwar als 2. erweiterte Bezeichnung für die Straße angegeben, kann aber auch als Zuweisung für bestimmte Abteilungen bei größeren Firmen oder Behörden genutzt werden.
- Bei der 2. Mahnung wurde kein offener Betrag mit ausgegeben. Unter MariaDB war außerdem das Datum nicht korrekt formatiert.

* XRechnung_2508_021
- Bei anderen Währungen: Button für den Start einer Website zur Währungsumrechnung
- Im Dialog zur Validierung wurde die Standardauswahl auf "Nein" gesetzt (ist einfach noch zu langsam?)
- In den XRechnungen werden nur noch Rechnungen, nicht Lieferscheine usw. als Vorbelege mit eingefügt.
- Angabe von Tagen beim Skonto wurde auf die maximal eingegebenen Tage in den Einstellungen begrenzt.
- Der Adresszusatz [BT-51] ist als Bestandteil der Adresse jetzt auch im PDF-Dokument direkt unter der Straße sichtbar.
- Bei Währungen, die von der Standardwährung abweichen, wird auch der Bruttobetrag in der Standardwährung berechnet, wenn der Wechselkurs bekannt ist. Die Bruttoberechnung in der Standardwährung wird im Rechnungsformular über der Summe in der Rechnungswährung angezeigt.

* XRechnung_2508_022
- Wenn Gutschriften erstellt wurden war der Ausgleich im Kontoformular nicht möglich. Eine von der Firma erstellte Gutschrift muss einen negativen Betrag auf dem Konto ergeben, war aber nur durch einen positiven Betrag ausgleichbar.

* XRechnung_2508_023
- Wechselkurs bei Rechnungen in anderen Währungen wird jetzt direkt von der EZB über einen Button geholt.
- Tipphilfe im Standardrechnungsformular erweitert, so dass immer mehr Felder aus der XRechnung mit ihren Zuordnungen ersichtlich werden.
- Das Lieferdatum wird jetzt auch im Rechnungsdruck, nicht nur in der XRechnung, durch das Rechnungsdatum vorbelegt. Wenn also kein Lieferdatum (als Leistungsdatum) gesetzt wurde, wird hier wie in der XRechnung verfahren. Nach § 14 Abs. 4 Satz 1 Nr. 6 UStG ist solch ein Leistungsdatum erforderlich.
- In der Mailerstellung wurden alternative Währungen zum ¤ nicht berücksichtigt. Jetzt auf die Währung eingestellt, die auch in der Rechnung erscheint.

* XRechnung_2508_024
- Der Bruttobetrag wurde durch den Wechselkurs bei der Kontoabrechnung irrtümlich dividiert - musste aber multipliziert werden. Betrifft nur Leute, die das Kontomodul und unterschiedliche Währungen nutzen.

* XRechnung_2508_025 (nur MariaDB)
- MariaDB: Datumsfehler bei Ansichten zum Skonto behoben (trat nur außerhalb von Base bei Addition von Tagen zu einem Datum auf, das im Folgemonat liegt)
- MariaDB: Rechnungssuche wurde nicht richtig aktualisiert, so dass eine Filterung das Schließen und Öffnen des Formulars erforderte.

* XRechnung_2508_026
- EMails mit Thunderbird versenden: Für Thunderbird wird der Mailversand jetzt über den -compose Befehl geregelt. Damit können ggf. auch Mails im html-format erzeugt werden. Außerdem funktioniert diese Variante auch bei Systemen, die mal gar keine Anhänge, mal alle Anhänge 3-fach in Thunderbird sahen. Es ist lediglich in den Einstellungen ein Eintrag für den Pfad zu Thunderbird notwendig. Hier reicht ggf. einfach "thunderbird".
- Mailtext: Der Text zu den Anhängen ging immer von der XRechnung (2 Dokumente) aus. Jetzt wird zwischen PDF + xml (XRechnung pur) und ZUGFeRD (xml in PDF) vom Text her unterschieden.
- Abweichende Währung: Bruttoangabe in der Standardwährung wurde als nicht formatierte Dezimalzahl angegeben. Jetzt mit 2 Dezimalstellen und Tausenderpunkt.

* XRechnung_2508_027
- Erstellung der PDF-Datei/XRechnung/ZUGFeRD: Änderungen im Rechnungsformular wurden nicht übernommen, wenn sie nicht im Rechnungsformular abgespeichert wurden.
- Eigene Nummerierungen wurden bei erweiterten Rechnungen nicht an untergliederte Inhalte weiter gegeben. Erfolgt jetzt automatisch.
- Fehlermeldung bei der Eindeutigkeit von Zeilennummerierungen korrigiert.
- Übertrag bei den PDF-Rechnungen wurde falsch positioniert, wenn in der Fußzeile Textfelder mehrzeilig gefüllt wurden.
- In erweiterten XRechnungen war die Angabe von Rabatten in den unteren Tabellen schreibgeschützt.
- Fremdwährungen: Beim Umstellen auf eine Fremdwährung wurde für die nächste Rechnung nicht auf die Standardwährung der Einstellungen zurückgesetzt.
- MariaDB: Durch ein Update bei MariaDB (oder aus anderen unbekannten Gründen) konnte die viw_Rechnung_Summe nicht als Filter für die Rechnungserstellung und auch für die Kontoführung der Rechnung genutzt werden. Änderungen der Beträge in der Kontoführung und Änderungen bei der Rechnung (nicht bei den Rechnungsposten) waren nicht möglich, weil die viw_Rechnung_Summe auch auf die tbl_Rechnung zugreift und deren Inhalt dann nicht mehr geändert werden darf. Das wurde durch die Erstellung einer temporären Tabelle mit dem erforderlichen Inhalt aus viw_Rechnung_Summe gelöst.
- Rundungsungenauigkeiten bei der Bestimmung offener Beträge wurden behoben (z.B. 35,425 ¤ sind gerundet 35,43 ¤; wird jetzt 35,425 ¤ - 35,43 ¤ gerechnet, so ergibt das einen Restbetrag von - 0,005 ¤. Gerundet wird daraus dann - 0,01 ¤)

* XRechnung_2508_028
- Nur MariaDB/MySQL: Im Druckmakro fehlte einmal die Deklaration des Statements. Die PDF-Datei wurde so nicht mit Inhalt gefüllt.

+++ Nächster Versionssprung bei LibreOffice +++
Die Base-Datei funktioniert weiterhin auch in den vorhergehenden Versionen von LibreOffice - dort kein Update nötig.
Unter Linux, zumindest der *.rpm-Variante, funktioniert der Treiber zur MariaDB leider zur Zeit nicht. Dort auf jeden Fall bei der Vorversion bleiben.

* XRechnung_2602_001
- MariaDB: Mahnformular zeigte keine zu mahnenden Rechnungen an. Inhalt des Formulars von Abfrage zu SQL-Code angepasst.
- Im Mahnungsformular wurde nicht der Name des Kunden angezeigt - korrigiert.
- Beim Filtern wurde im Rechnungsformular immer zum letzten Datensatz des Kundenformular gesprungen. Auskommentiert.
- Währungsformat für englischsprachige Rechnungen konnte nicht ermittelt werden, da im Code [ROT] statt [RED] stand. Korrigiert.

* XRechnung_2602_002
- MariaDB: viw_Rechnung_Summe (und folgende Ansichten) konnten bei einem Refresh der Anzeige nicht gelesen werden. Code angepasst.
- viw_Rechnung_Summe: Mahnungen ohne Kosten aus der Übersicht entfernt.
- viw_Rechnung: Skontoangaben wurden in den Zahlungsnotizen immer nach den Angaben in den Firmeneinstellungen erstellt, nicht gestaffelt zuerst nach tbl_Rechnung, dann nach tbl_Kunde und schließlich nach tbl_Firma. Korrigiert.

* XRechnung_2602_003
- MariaDB: in tbl_Firma wurde das Feld "Validieren" nicht erstellt. Das Feld wurde stattdessen in tbl_Rechnung erstellt. Korrigiert.
- Rechnungen mit negativen Beträgen wurden nicht aufsummiert - korrigiert.

* XRechnung_2602_004
- Die automatisch generierte Rechnung wurde bisher nicht gespeichert. Bei Änderungen der Einstellung zu der Erstellung der Rechnungsnummern waren so auch alte Rechnungsnummern betroffen und wurden geändert. Jetzt wird die generierte Nummer in das Feld für den Rechnungsnamen übertragen, sofern dort nicht bereits eine andere Rechnungsnummer gespeichert ist. Die Übertragung kann in dem Einstellungen angeschaltet werden. Die Nummer erscheint dann unter "Rechnungsnummer vorgeben als:"
- MariaDB: Rechnungen konnten über das Formular nicht gelöscht werden, auch wenn sie noch gar nicht mit einer Rechnungsnummer versehen waren. Im Makrocode korrigiert.
- MariaDB: An einigen Stellen im Makro wurde SQL-Code nicht ausgeführt, da bei MariaDB das Statement jedes mal neu definiert werden muss. Vermutlich wurden die Funktionen bisher nicht weiter genutzt, so dass dies niemandem aufgefallen ist.

* XRechnung_2602_005
- ZUGFeRD: Zustelladresse wurde durch einen Schreibfehler in der Variablen nie gesondert übernommen.
- Beim Ansprechpartner wurde immer Vorname und Nachname für die Rechnung ausgegeben. Auch Nachfrage ist jetzt auch ein Feld "AnsprechPNachname" für das Rechnungsformular auswählbar.
- MariaDB: Neue Rechnungen konnten nur nach Neustart der Base-Datei auch bei der Kontoführung erscheinen. Korrigiert.

* XRechnung_2602_006
- ZUGFeRD: Die vom Empfänger zugewiesene Lieferantennummer wurde irrtümlich als GlobalID in die XML-Datei übernommen. Jetzt ist die Lieferantennummer als ID verfügbar. Das vorherige Verfahren war nicht falsch, wurde aber in den Routinen einer größeren Firma als fehlendes Feld ausgewiesen und die Rechnung nicht angenommen. Tatsächlich sind aber nur der Firmenname und die Mailadresse nach XRechnung Pflicht für den Lieferanten.

* XRechnung_2602_007
- Die Zahlungsnotiz war irrtümlich als Pflichtfeld in den XRechnungen bzw. ZUGFeRD-Rechnungen vorgegeben. Dadurch entstanden bei nicht vorhandener Notiz leere Elemente. Für beide Rechnungstypen behoben.
- Lieferungsimport: Manche Software packt alle möglichen Texte im xml-Dokument in eine Klammerung aus <![CDATA[ und ]]> . Abgesehen davon, dass damit die Validität von Code-Feldern nicht mehr gewährleistet ist lassen sich die Daten mit diesem "Zusatztext" natürlich nicht in alle möglichen Tabellenfelder schreiben. Diese Klammerung wird jetzt durch eine entsprechende Funktion vor dem Import entfernt.
- Lieferungsimport: Einige Pflichtfelder beim Import aus ZUGFeRD-xml-Dateien werden, wenn nicht vorhanden, durch andere entsprechende Einträge ersetzt (z.B. Mailadresse der Firma fehlt, dafür Mailadresse im Kontakt vorhanden)
- Validierung: Die Datei wird jetzt über einen Shell-Befehl direkt im Archiv erstellt. So liegen die Validierungsdateien direkt bei den entsprenden Rechnungsdateien.
- MariaDB: Es fehlten Verknüpfungen einiger Tabellen. Mit dem Makro zum Update von einer früheren Version behoben.
